<?php
define("CMS", "korCMS");
require_once("../functions.php");    // access from admin folder
checkInstallation(true); // admin call
require_once("../config/odyssey.ini.php");    // access from admin folder
$versionType = "";
$versionFile = "version.php";
if (is_file($versionFile)) {
    include($versionFile); // includes the $thisVersion variable
    $currentVersion = $thisVersion;
}

setErrorReporting();
getHeaders();

$protocol = getProtocol();
$domainPath = $protocol . "://" . $_SERVER['HTTP_HOST'] . "/";
$imports = array();
$library = array();
$phrases = array();
import("library.*", true); // load all Odyssey classes from admin

$messages = new messages();
$auth = new authentication(false);
$db = new db();
$language = new language();
$initialAdminLanguage = getAdminLanguage();
$langID = $initialAdminLanguage; // set the initial admin language ID
$categories = new categories();
$content = new content();
$dates = new dates();
$fileSystem = new fileSystem();
$menu = new menu();
$parameters = new parameters();
$system = new system();
$variables = new variables();
$banners = new banners();
$document = new document(NULL, NULL, true);
$force_ssl = $parameters->getParameter("ssl"); // if force SSL URL is enabled or not
if($force_ssl && $protocol != 'https'){ // then force URL to use https
    setSSL();
}
$db->query("SET NAMES 'utf8mb4'");
$db->clearCache(); // no database caching in admin panel
$system->clearLog();

if ($_POST["loginSubmit"]) {
    $auth->setAdminUser(md5($_POST["username"]));
    $auth->setAdminPass(md5($_POST["password"]));
    $_SESSION["enteredUsername"] = md5($_POST["username"]);
    $_SESSION["enteredPassword"] = md5($_POST["password"]);
}
$auth->setAdminUser($_SESSION["enteredUsername"]);
$auth->setAdminPass($_SESSION["enteredPassword"]);
if ((int)$_GET['logout'] == 1) {
    $auth->logout(true); // admin logout
    echo "<script type='text/javascript'>document.location.href='index.php';</script>";
    exit;
}
$_SESSION['ip'] = $_SERVER["REMOTE_ADDR"];
$modulesFieldTypes = array("textfield", "checkbox", "select", "multiselect", "section", "date", "colorpicker", "sprite", "textarea", "form", "mediabank", "gmap", "items"); // for module's parameters fields
$modulesSystemVarNames = array("marginTop", "marginRight", "marginBottom", "marginLeft", "paddingTop", "paddingRight", "paddingBottom", "paddingLeft");
$spritePath = "../mediabank/icons/";
$spriteExt = "png";
$auth = new authentication($_GET['action'] != "login");

$system_fields = array('id', 'active', 'private', 'sort', 'alias', 'parent', 'target', 'access', 'lat', 'lng', 'zoom', 'mainID', 'langID', 'view', 'section', 'day', 'month', 'year', 'admin_pagination', 'authentication', 'banners', 'basket', 'blog', 'categories', 'content', 'css', 'dates', 'db', 'document', 'fileSystem', 'iconResize', 'imageResize', 'language', 'menu', 'messages', 'pagination', 'parameters', 'sef', 'system', 'timer', 'variables');

$system_tables = array('banners', 'banner_slots', 'banner_types', 'basket', 'basket_modes', 'basket_types', 'cities', 'counties', 'css', 'events', 'fields', 'files', 'filetypes', 'fpa_cat', 'images', 'keys', 'languages', 'menu_preview', 'mediabank', 'menu_options', 'options_table_sections', 'pages', 'pranges', 'presults', 'presults_numbers', 'preview_map', 'selectlists', 'system_settings', 'sections', 'transaltions', 'users', 'users_types', 'videos', 'extensions', 'extensions_types', 'modules', 'templates', 'sections', 'admin_favorites', 'aliases', 'blog', 'blogcategories', 'blogcomments', 'comments', 'css_important', 'odyssey_index', 'seo', 'slots', 'tags', 'translations', 'forms', 'forms_categories', 'ff', 'fftypes', 'forms_selects', 'articles', 'permissions', 'facebook', 'admin_shortcuts', 'fieldsets', 'cat_access');

$nonMultilingualSections = array("users", "slots", "banner_slots", "banner_types");

$nonAddToSelectSections = array("counties", "facebook", "menu_preview", "system_settings", "pranges", "menu_options", "events", "preview_map", "users_types", "pages", "banner_types", "banners", "presults_numbers", "modules", "templates", "extensions_types", "extensions", "sections", "odyssey_index", "aliases", "comments", "fftypes", "forms", "permissions", "forms_selects", "ff");

$db->query("SET NAMES 'utf8mb4'");
require("admin_modules.php");
?>
