<?php 
define("CMS", "korCMS");
error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED); 
session_start();

$versionFile = "version.php";
if(is_file($versionFile)) include($versionFile); // includes the $thisVersion variable

$installLanguage = $_SESSION['installLanguage'];
$installLanguage = ($installLanguage) ? $installLanguage : 2; // set english language as initial language if no language defined

function importSQL($file, $delimiter = ';'){
	global $messages;
	$dbHost = $_SESSION['dbHost'];
	$dbName = $_SESSION['dbName'];
	$dbUser = $_SESSION['dbUser'];
	$dbPass = $_SESSION['dbPass'];
	$dbLink = mysqli_connect($dbHost, $dbUser, $dbPass, $dbName);
	set_time_limit(0);
	if (is_file($file) === true){
		$file = fopen($file, 'r');
		if (is_resource($file) === true){
			$query = array();
			while (feof($file) === false){
				$query[] = fgets($file);
				if (preg_match('~' . preg_quote($delimiter, '~') . '\s*$~iS', end($query)) === 1){
					$query = trim(implode('', $query));
					if(!mysqli_query($dbLink, $query)){
						$messages->addError("Could not execute MySQL query! Query was: ".$query);
					}
					while (ob_get_level() > 0){
						ob_end_flush();
					}
					flush();
				}
				if (is_string($query) === true){
					$query = array();
				}
			}
			return fclose($file);
		}else{
			die("Setup SQL file is not a valid resource");
		}
	}else{
		die("Setup SQL file not found");
	}
	return false;
}


//email validation functions -----------------------------------------------------------------------------------------------------------------------

function win_checkdnsrr($host, $type='MX') { // checkdnsrr() support for Windows
    if (strtoupper(substr(PHP_OS, 0, 3)) != 'WIN') { return; }
    if (empty($host)) { return; }
    $types=array('A', 'MX', 'NS', 'SOA', 'PTR', 'CNAME', 'AAAA', 'A6', 'SRV', 'NAPTR', 'TXT', 'ANY');
    if (!in_array($type,$types)) {
        user_error("checkdnsrr() Type '$type' not supported", E_USER_WARNING);
        return;
    }
    @exec('nslookup -type='.$type.' '.escapeshellcmd($host), $output);
    foreach($output as $line){
        if (preg_match('/^'.$host.'/',$line)) { return true; }
    }
}
if (!function_exists('checkdnsrr')) {
    function checkdnsrr($host, $type='MX') {
        return win_checkdnsrr($host, $type);
    }
}


function validEmail($email)
{
   $isValid = true;
   $atIndex = strrpos($email, "@");
   if (is_bool($atIndex) && !$atIndex)
   {
      $isValid = false;
   }
   else
   {
      $domain = substr($email, $atIndex+1);
      $local = substr($email, 0, $atIndex);
      $localLen = strlen($local);
      $domainLen = strlen($domain);
      if ($localLen < 1 || $localLen > 64)
      {
         // local part length exceeded
         $isValid = false;
      }
      else if ($domainLen < 1 || $domainLen > 255)
      {
         // domain part length exceeded
         $isValid = false;
      }
      else if ($local[0] == '.' || $local[$localLen-1] == '.')
      {
         // local part starts or ends with '.'
         $isValid = false;
      }
      else if (preg_match('/\\.\\./', $local))
      {
         // local part has two consecutive dots
         $isValid = false;
      }
      else if (!preg_match('/^[A-Za-z0-9\\-\\.]+$/', $domain))
      {
         // character not valid in domain part
         $isValid = false;
      }
      else if (preg_match('/\\.\\./', $domain))
      {
         // domain part has two consecutive dots
         $isValid = false;
      }
      else if
(!preg_match('/^(\\\\.|[A-Za-z0-9!#%&`_=\\/$\'*+?^{}|~.-])+$/', str_replace("\\\\","",$local)))
      {
         // character not valid in local part unless 
         // local part is quoted
         if (!preg_match('/^"(\\\\"|[^"])+"$/', str_replace("\\\\","",$local)))
         {
            $isValid = false;
         }
      }
      if ($isValid && !(checkdnsrr($domain)))
      {
         // domain not found in DNS
         $isValid = false;
      }
   }
   return $isValid;
}

// end of email validation functions -----------------------------------------------------------------------------------------------------------------------






require_once("../library/messages.php");

$messages = new messages();

function t($key){
$translations = array(
'Πρέπει να ακολουθήσετε με την σειρά τα βήματα της εγκατάστασης'=>'Please follow the installation steps',
'Πρέπει να ορίσετε το όνομα της βάσης δεδομένων'=>'The database name is required',
'Πρέπει να ορίσετε το όνομα του χρήστη για την βάση δεδομένων'=>'The database user name is required',
'Πρέπει να ορίσετε τον κωδικό του χρήστη για την βάση δεδομένων'=>'The user password for the database is required',
'Δεν επιβεβαιώσατε σωστά τον κωδικό του χρήστη για την βάση δεδομένων'=>'The user password for the database needs to be confirmed correctly',
'Δεν ήταν δυνατή η σύνδεση στη βάση δεδομένων με αυτά τα στοιχεία'=>'Could not connect to database with these credentials',
'Δεν ήταν δυνατή η σύνδεση στη συγκεκριμένη βάση δεδομένων'=>'Could not connect to database',
'Πρέπει να ορίσετε το FTP hostname'=>'The FTP hostname is required',
'Πρέπει να ορίσετε το όνομα του χρήστη για την πρόσβαση FTP'=>'The FTP user name is required',
'Πρέπει να ορίσετε τον κωδικό του χρήστη για την πρόσβαση FTP'=>'The FTP user password is required',
'Δεν επιβεβαιώσατε σωστά τον κωδικό του χρήστη για την πρόσβαση FTP'=>'The FTP user password needs to be confirmed correctly',
'Δεν ήταν δυνατή η σύνδεση στο FTP αυτού του διακομιστή'=>'Could not connect to FTP',
'Δεν ήταν δυνατή η είσοδος στο FTP με αυτά τα στοιχεία'=>'Could not connect to FTP with these credentials',
'Πρέπει να ορίσετε το domain name του site'=>'The domain name is required',
'Πρέπει να ορίσετε ένα e-mail επικοινωνίας'=>'The e-mail address is required',
'Η e-mail διεύθυνση που δηλώσατε δεν είναι υπαρκτή'=>'Invalid e-mail address',
'Πρέπει να ορίσετε τον κωδικό του Master Admininstrator'=>'The Master Admininstrator password is required',
'Πρέπει να ορίσετε τον κωδικό του Client Admininstrator'=>'The Client Admininstrator password is required',
'Δεν επιβεβαιώσατε σωστά τον κωδικό του Master Admininstrator'=>'The Master Admininstrator password needs to be confirmed correctly',
'Δεν επιβεβαιώσατε σωστά τον κωδικό του Client Admininstrator'=>'The Client Admininstrator password needs to be confirmed correctly',
'Δεν βρέθηκε ο φάκελος συστήματος με όνομα [config]'=>'The [config] system folder was not found',
'Ο φάκελος συστήματος [config] δεν είναι εγγράψιμος'=>'The [config] system folder is not writeable',
'Δεν βρέθηκε το configuration file στον φάκελο συστήματος [config]'=>'No configuration file found inside the [config] system folder',
'Δεν ήταν δυνατή η σύνδεση στη βάση δεδομένων με τα στοιχεία login του config'=>'Could not connect to database using the configuration credentials',
'στον φάκελο συστήματος [admin]'=>'in the [admin] system folder',
'Δεν βρέθηκε το εναρκτήριο SQL file'=>'Could not locate the database installation SQL file',
'Η εγκατάσταση ολοκληρώθηκε με επιτυχία!'=>'The installation completed successfully!',
'Παρουσιάστηκε κάποιο σφάλμα κατά την ανάγνωση του SQL αρχείου'=>'An error occurred reading the SQL file', 
'Επόμενο βήμα της εγκατάστασης'=>'Next step',
'Δεν μπορείτε να προχωρήσετε στο επόμενο βήμα της εγκατάστασης'=>'Please complete the previous step of installation',
'Βεβαιωθείτε πως δεν υπάρχουν σφάλματα και πως έχετε συμπληρώσει τυχόν απαιτούμενα πεδία φόρμας'=>'Make sure that all required fields are filled in and no errors exist',
'Εγκατάσταση του'=>'Installation of',
'εδώ'=>'here',
'Το Odyssey CMS έχει ήδη εγκατασταθεί'=>'Odyssey CMS is already installed',
'Βρέθηκε το αρχείο [config/odyssey.ini.php]'=>'The [config/odyssey.ini.php] has been found',
'Για να αρχίσετε μια νέα εγκατάσταση, θα πρέπει να διαγράψετε το συγκεκριμένο αρχείο'=>'To begin a new installation, you need to remove this file',
'Αν θέλετε να το εγκαταστήσετε ξανά, θα πρέπει να διαγράψετε το αρχείο'=>'To install it again you need to remove the file',
'Στην περίπτωση αυτή, παρακαλούμε αποθηκεύστε τυχόν δεδομένα που έχετε στην υπάρχουσα βάση δεδομένων'=>'In this case, please backup your database data',
'Το πρώτο πράγμα που πρέπει να κάνετε πριν προχωρήσετε στην εγκατάσταση, είναι η δημιουργία μιας βάσης δεδομένων mySQL και ενός χρήστη με πρόσβαση σε αυτήν'=>'First of all you must create a database, a user and a password for this database',
'Για παράδειγμα το όνομα της βάσης και του χρήστη θα μπορούσε να είναι «odyssey», με ένα password της επιλογής σας. Τα στοιχεία αυτά θα σας ζητηθούν κατά την εγκατάσταση'=>'For example you can create a database and a user named «odyssey» defining a password of your choice. You will be asked for these credentials during the installation',
'Για να το επιτύχετε αυτό, μπορείτε να χρησιμοποιήσετε ένα εργαλείο διαχείρισης βάσης δεδομένων όπως το phpMyAdmin το οποίο διαθέτουν οι περισσότεροι διακομιστές'=>'You can easily create the database using a tool such as the phpMyAdmin, available in most servers',
'Σχετικά βοηθήματα σε youTube videos μπορείτε να βρείτε'=>'Some good youTube tutorials can be found',
'Στη συνέχεια η εγκατάσταση θα σας οδηγήσει με τα κατάλληλα βήματα, ώστε να ολοκληρώσετε την διαδικασία. Το περιβάλλον του διακομιστή σας θα πρέπει να πληροί τις κάτωθι απαιτήσεις'=>'Then just follow the installation step by step. Server requirements are the following',
'Έκδοση PHP >= 5.2.9'=>'PHP version >= 5.2.9',
'Δυνατότητα εκτέλεσης κρυπτογραφημένου κώδικα με IonCube'=>'IonCube loader support',
'Δυνατότητα διαχείρισης zip αρχείων μέσω της Zlib library'=>'Zlib library support',
'Δυνατότητα διαχείρισης xml αρχείων μέσω της SimpleXML'=>'SimpleXML support',
'Δυνατότητα υποστήριξης mysql / mysqli / mySQL PDO'=>'mysql / mysqli / mySQL PDO database support',
'Προσοχή! Η «allow_url_fopen» δεν έχει οριστεί σωστά'=>'Warning! The «allow_url_fopen» is not set correctly',
'Η ρύθμιση ( «allow_url_fopen» ) στο php.ini πρέπει να έχει τιμή «1» για να έχετε δυνατότητα SEF URLs'=>'The ( «allow_url_fopen» ) option in php.ini must be equal to «1» in order to enable the SEF Urls',
'Επίσης θα πρέπει να υποστηρίζεται η CURL και να ορίσετε εγγράψιμα δικαιώματα ώστε το script να έχει πρόσβαση στους ακόλουθους φακέλους'=>'The support of CURL is also required.<br>Set writeable permissions to the  following folders:',
'Επόμενο βήμα'=>'Next step',
'Το σύστημα απαιτεί έκδοση PHP '=>'The required PHP version must be >= 5.2.9',
'Έλεγχος επιτυχής'=>'Success',
'Το σύστημα σας δεν υποστηρίζει εκτέλεση κρυπτογραφημένου κώδικα με IonCube'=>'IonCude not supported',
'Το σύστημα σας δεν υποστηρίζει διαχείριση zip αρχείων'=>'Zlib library not supported',
'Το σύστημα σας δεν υποστηρίζει διαχείριση xml αρχείων με SimpleXML'=>'SimpleXML not supported',
'Το σύστημα σας δεν υποστηρίζει mySQL για την διαχείριση της βάσης δεδομένων'=>'mySQL database not supported',
'Ενεργοποίηση της «allow_url_fopen» στο php.ini'=>'Activation of the «allow_url_fopen» option in php.ini',
'Η «allow_url_fopen» δεν έχει οριστεί ως ενεργή στο php.ini'=>'The «allow_url_fopen» option in php.ini is not active',
'Έλεγχος των φακέλων για εγγράψιμα δικαιώματα (permissions)'=>'Checking folder for writable permissions',
'Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος'=>'This folder is not writeable',
'Σας προτείνουμε να δώσετε εγγράψιμα δικαιώματα και στα αρχεία'=>'It is recommended to set writeable permissions to the files',
'ώστε να καταγράφονται τυχόν σφάλματα που σχετίζονται με την βάση δεδομένων'=>'in order to log any database errors',
'επιβεβαίωση'=>'confirm',
'E-mail επικοινωνίας'=>'Contact e-mail address',
'Μετάβαση στον πίνακα διαχείρισης'=>'Go to admin panel',
'Οδηγίες εγκατάστασης'=>'Installation instructions',
'Έλεγχος συνθηκών εγκατάστασης'=>'System configuration',
'Ορισμός στοιχείων βάσης δεδομένων'=>'Database configuration',
'Ορισμός παραμέτρων ιστότοπου'=>'Website configuration',
'Εισαγωγή εγγραφών στη βάση δεδομένων'=>'Importing database',
'Βήμα'=>'Step',
'δοκιμάστε ξανά'=>'please try again',
'Διατήρηση demo περιεχομένου'=>'Keep the demo content',
'ο:'=>'&nbsp;'
);
global $installLanguage;
if((int)$installLanguage == 1) return $key; // return greek expression
return ($translations[$key]) ? $translations[$key] : $key; // try to return an english translation
}

$steps = array(
t("Οδηγίες εγκατάστασης"), 
t("Έλεγχος συνθηκών εγκατάστασης"),
t("Ορισμός στοιχείων βάσης δεδομένων"),
t("Ορισμός παραμέτρων ιστότοπου"),
t("Εισαγωγή εγγραφών στη βάση δεδομένων"),
);


$step = (empty($_REQUEST['step'])) ? 0 : (int)$_REQUEST['step'];
$error = false;
if($step == 1){
	$phpVersionError = (!(strnatcmp(phpversion(),'5.2.9') >= 0));
	if($phpVersionError) $error = true;

	$ioncubeError = (!(in_array("ionCube Loader", get_loaded_extensions())));	
	if($ioncubeError) $error = true;
	
	$zipError = (!(function_exists('zip_open')));
	if($zipError) $error = true;
	
	$xmlError = (!(function_exists('simplexml_load_file')));
	if($xmlError) $error = true;
	
	$sqlError = (!(function_exists('mysqli_connect')));
	if($sqlError) $error = true;
	
	$w_admin_uploads = is_writable("uploads/");
	$w_admin_uploads_medium = is_writable("uploads/medium/");
	$w_admin_uploads_thumbs = is_writable("uploads/thumbs/");	
	$w_admin_xml = is_writable("xml/");		
	$w_config = is_writable("../config/");		
	$w_controller = is_writable("../controller/");		
	$w_fonts = is_writable("../fonts/");		
	$w_modules = is_writable("../modules/");		
	$w_templates = is_writable("../templates/");		
	$w_mediabank = is_writable("../mediabank/");		
	$w_mediabank_banner = is_writable("../mediabank/banners/");		
	$w_mediabank_flags = is_writable("../mediabank/flags/");		
	$w_mediabank_icons = is_writable("../mediabank/icons/");		
	$w_mediabank_images = is_writable("../mediabank/images/");		
	$w_mediabank_medium = is_writable("../mediabank/medium/");		
	$w_mediabank_thumbs = is_writable("../mediabank/thumbs/");		
	$w_uploads = is_writable("../uploads/");
	
	if(!$error){
		if(!$w_admin_uploads) $error = true;
		if(!$w_admin_uploads_medium) $error = true;
		if(!$w_admin_uploads_thumbs) $error = true;
		if(!$w_admin_xml ) $error = true;
		if(!$w_config) $error = true;
		if(!$w_controller) $error = true;
		if(!$w_fonts) $error = true;
		if(!$w_modules) $error = true;
		if(!$w_templates) $error = true;
		if(!$w_mediabank) $error = true;
		if(!$w_mediabank_banner) $error = true;
		if(!$w_mediabank_flags) $error = true;
		if(!$w_mediabank_icons) $error = true;
		if(!$w_mediabank_images) $error = true;
		if(!$w_mediabank_medium) $error = true;
		if(!$w_mediabank_thumbs) $error = true;
		if(!$w_uploads) $error = true;
	}
	if(!$error) $_SESSION['step1'] = true;
}


if($step == 2 && $_REQUEST['checkDB']){
	if(!$_SESSION['step1']) {
		$messages->addError(t("Πρέπει να ακολουθήσετε με την σειρά τα βήματα της εγκατάστασης"), true);
		header("location:install.php");
	}
	$dbHost = (empty($_POST['dbHost'])) ? "localhost" : $_POST['dbHost'];
	$dbName = $_POST['dbName'];
	$dbUser = $_POST['dbUser'];
	$dbPass = $_POST['dbPass'];
	$dbPassConfirm = $_POST['dbPassConfirm'];
	if(empty($dbName)) $messages->addError(t("Πρέπει να ορίσετε το όνομα της βάσης δεδομένων"));
	if(empty($dbUser)) $messages->addError(t("Πρέπει να ορίσετε το όνομα του χρήστη για την βάση δεδομένων"));
	if(empty($dbPass)) $messages->addError(t("Πρέπει να ορίσετε τον κωδικό του χρήστη για την βάση δεδομένων"));
	if(!empty($dbPass) || !empty($dbPassConfirm)){
		if($dbPass != $dbPassConfirm) $messages->addError(t("Δεν επιβεβαιώσατε σωστά τον κωδικό του χρήστη για την βάση δεδομένων"));
	}
	if(!$messages->hasErrors){ // try to connect...
		@$dbLink = mysqli_connect($dbHost, $dbUser, $dbPass, $dbName);
		if(!$dbLink) {
			$messages->addError(t("Δεν ήταν δυνατή η σύνδεση στη βάση δεδομένων με αυτά τα στοιχεία"));
		}else{
			if(!mysqli_select_db($dbLink, $dbName)) $messages->addError(t("Δεν ήταν δυνατή η σύνδεση στη συγκεκριμένη βάση δεδομένων"));
		}
	}
	if(!$messages->hasErrors) $_SESSION['step2'] = true;
}


if($step == 3 && $_REQUEST['checkParameters']){
	if(!$_SESSION['step2']) {
		$messages->addError(t("Πρέπει να ακολουθήσετε με την σειρά τα βήματα της εγκατάστασης"), true);
		header("location:install.php");
	}
	$domain_name = $_POST['domain_name'];
	$email_address= $_POST['email_address'];
	$adminPass = $_POST['adminPass'];
	$adminPassConfirm = $_POST['adminPassConfirm'];
	$clientPass = $_POST['clientPass'];
	$clientPassConfirm = $_POST['clientPassConfirm'];	
	$_SESSION['keep_demo_content'] = $_POST['keep_demo_content'];
	if(empty($domain_name)) $messages->addError(t("Πρέπει να ορίσετε το domain name του site"));
	if(empty($email_address)) {
		$messages->addError(t("Πρέπει να ορίσετε ένα e-mail επικοινωνίας"));
	}else{
		if(!validEmail($email_address)) $messages->addError(t("Η e-mail διεύθυνση που δηλώσατε δεν είναι υπαρκτή"));
	}
	if(empty($adminPass)) $messages->addError(t("Πρέπει να ορίσετε τον κωδικό του Master Admininstrator"));
	if(empty($clientPass)) $messages->addError(t("Πρέπει να ορίσετε τον κωδικό του Client Admininstrator"));
	if(!empty($adminPass) || !empty($adminPassConfirm)){
		if($adminPass != $adminPassConfirm) $messages->addError(t("Δεν επιβεβαιώσατε σωστά τον κωδικό του Master Admininstrator"));
	}
	if(!empty($clientPass) || !empty($clientPassConfirm)){
		if($clientPass != $clientPassConfirm) $messages->addError(t("Δεν επιβεβαιώσατε σωστά τον κωδικό του Client Admininstrator"));
	}	
	if(!$messages->hasErrors){
		$path = "../config/";
		$ini = "odyssey.ini.php";
		$filename = $path.$ini;
		if(!is_dir($path)) {
			$messages->addError(t("Δεν βρέθηκε ο φάκελος συστήματος με όνομα [config]"));
		}
		if(!is_writable($path)) {
			$messages->addError(t("Ο φάκελος συστήματος [config] δεν είναι εγγράψιμος"));
		}		
		$varSign = "$";
		if(!$messages->hasErrors){
			$fp = fopen($filename, "w+");
			chmod($filename, 0777);
			fputs($fp, '<?php'.PHP_EOL);
			fputs($fp, $varSign.'versionFile = "admin/version.php";'.PHP_EOL);
			fputs($fp, 'if(is_file('.$varSign.'versionFile)){'.PHP_EOL);
			fputs($fp, 'include('.$varSign.'versionFile); // includes the '.$varSign.'thisVersion variable'.PHP_EOL);
			fputs($fp, $varSign.'currentVersion = '.$varSign.'thisVersion;'.PHP_EOL);
			fputs($fp, '}'.PHP_EOL);			
			fputs($fp, $varSign.'dbHost = "'.str_replace('"', null, $_SESSION['dbHost']).'";'.PHP_EOL);
			fputs($fp, $varSign.'dbName = "'.str_replace('"', null, $_SESSION['dbName']).'";'.PHP_EOL);
			fputs($fp, $varSign.'dbUser = "'.str_replace('"', null, $_SESSION['dbUser']).'";'.PHP_EOL);
			fputs($fp, $varSign.'dbPass = "'.str_replace('"', null, $_SESSION['dbPass']).'";'.PHP_EOL);
			fputs($fp, $varSign.'domain_name = "'.str_replace('"', null, $_POST['domain_name']).'";'.PHP_EOL);
			fputs($fp, $varSign.'adminPass = "'.str_replace('"', null, md5($_POST['adminPass'])).'";'.PHP_EOL);
			fputs($fp, $varSign.'clientPass = "'.str_replace('"', null, md5($_POST['clientPass'])).'";'.PHP_EOL);
			fputs($fp, $varSign.'email_address = "'.str_replace('"', null, $_POST['email_address']).'";'.PHP_EOL);
			fputs($fp, $varSign.'currency = "€";'.PHP_EOL);
			fputs($fp, $varSign.'doNotShowSocial = true; // do not show social icons @localhost'.PHP_EOL);
			fputs($fp, $varSign.'constantMediumHeight = 0; // if we want to have fix height in medium images (it will be distored), we set the number of pixels here, otherwise set it to zero!'.PHP_EOL);
			fputs($fp, $varSign.'activationNeeded = true; // if need to activate registration via confirmation Code sent by email'.PHP_EOL);
			fputs($fp, $varSign.'stickyAdminHeader = true;'.PHP_EOL);
			fputs($fp, $varSign.'openAllLanguages = false;'.PHP_EOL);
			fputs($fp, $varSign.'doNotRemoveHtmlComments = false;'.PHP_EOL);
			
$config_content=PHP_EOL.PHP_EOL.$varSign.'order = array("articles"=>"articles.published DESC, articles.id DESC, content_articles.title"); 

// The following sections will be linked to calendar (a date type field must be provided)
'.$varSign.'useCalendar = array(
"news",
"articles",
);
// The following sections will be able to use tags
'.$varSign.'useTags = array(
"news",
"articles",
"products",
"blog"
);
// Force sections defined as array keys to be sort by category defined as field name in array value
'.$varSign.'sort_categories = array(
/* for eaxample "section_name"=>"id_field_name" */
);
';	
			fputs($fp, $config_content.PHP_EOL);		
			fputs($fp, '?>');
			fclose($fp);
		}		
	}
	if(!$messages->hasErrors) $_SESSION['step3'] = true;
}

if(($step == 4) && $_SESSION['step3']){ // insert db data
	$path = "../config/";
	$ini = "odyssey.ini.php";
	$filename = $path.$ini;
	if(!is_file($filename)) {
		$messages->addError(t("Δεν βρέθηκε το configuration file στον φάκελο συστήματος [config]"));
	}else{
		include($filename);
		if(!mysqli_connect($dbHost, $dbUser, $dbPass, $dbName)) {
			$messages->addError(t("Δεν ήταν δυνατή η σύνδεση στη βάση δεδομένων με τα στοιχεία login του config"));
		}
	}
	$sqlFile = "odyssey_install.sql";
	if(!is_file($sqlFile)) $messages->addError(t("Δεν βρέθηκε το εναρκτήριο SQL file")." [".$sqlFile."] ".t("στον φάκελο συστήματος [admin]"));	
	if(!$messages->hasErrors){ // proceed to db dumping
		if(importSQL($sqlFile)){
			$messages->addMessage(t("Η εγκατάσταση ολοκληρώθηκε με επιτυχία!"));
			$_SESSION['step4'] = true;
		}else{
			$messages->addError(t("Παρουσιάστηκε κάποιο σφάλμα κατά την ανάγνωση του SQL αρχείου"));
		}
	}
	
}
?>

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Odyssey Setup</title>
<link rel="shortcut icon" href="favicon.ico">
<link href="css/admin.css" rel="stylesheet" type="text/css">
<link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" src="js/jquery-impromptu.js"></script>
<script type="text/javascript" language="javascript">
function check(step){
	var error = <?php echo empty($error) ? 'false' : 'true';?>;
	if(step < 2){
		return !error;
	}
	return false;
}

function setInstallLanguage(selectObject){
	var langID = $(selectObject).val();
	jQuery.ajax({
		type: "POST",
		url: "install_language.php",
		data: "installLanguage="+langID,
		async: false,
		success: function(response){
			if(parseInt(response) == 1) document.location.href = "install.php";
		}
	});	
}
</script>
<style type="text/css">
table tr td {
	color: #414141;
}
.folder_container {
	display: inline-block;
	position: relative;
}
.folder {
	position: absolute;
	left: -30px;
	top: -20px;
}
.admin_form_element {
	color: #9a2a54 !important;
}
</style>
</head>
<body style="background:#EFEFEF">
<section class="container">
    <div class="group"  style="background-color: white; padding: 30px; border: 1px solid silver;">
        <div class="grid-12"> <img src="images/odyssey_install_logo.png" alt="Odyssey CMS" style="margin-bottom: 20px">
            <div style="float:right">
                <div style="text-align:right"> <a href="#" onclick="if(check(<?php echo $step;?>)){$('#installForm').submit();}else{popup(t('Δεν μπορείτε να προχωρήσετε στο επόμενο βήμα της εγκατάστασης')+'\n'+t('Βεβαιωθείτε πως δεν υπάρχουν σφάλματα και πως έχετε συμπληρώσει τυχόν απαιτούμενα πεδία φόρμας'), 'popup-warning');}"><img src="images/install_next.png" width="60" height="60" alt="next step" title="<?php echo t("Επόμενο βήμα της εγκατάστασης");?>"></a> <br>
                    <?php
            if(empty($step)){
            ?>
                    <div class="admin_form_element">
                        <div class="admin_label">
                            <p>Installation Language</p>
                        </div>
                        <div>
                            <select name="installLanguage" class="listbox" onchange="setInstallLanguage(this)">
                                <option value="1" <?php if($installLanguage == "1") echo "selected";?>>Greek</option>
                                <option value="2" <?php if($installLanguage == "2") echo "selected";?>>English</option>
                            </select>
                        </div>
                    </div>
                    <?php
            }
            ?>
                </div>
            </div>
        </div>
    </div>
    <div class="group" style="background-color: #3c212f; border:1px solid #485667; color:#fff; padding: 5px 10px; width: 90%; margin: -20px auto 0 auto;">
        <div class="grid-6" style="font-size: 1.5em; color:#fff;">
            <?php 
		$title = (empty($step)) ? $steps[$step] : "<span style='color: #e81867;'>".t("Βήμα")." ". $step.t("ο:")."</span> ".$steps[$step];
		echo  $title;
		?>
        </div>
        <div class="grid-6" style="text-align:right; color: #c0c0c0; line-height:1.5em"> <span style="padding-right: 8px; "><?php echo t("Εγκατάσταση του");?> Odyssey CMS v.<?php echo $thisVersion;?></span> </div>
    </div>
    <form id="installForm" action="install.php" method="post">
        <?php
if(empty($step)){
	$messages->importSessionMessages();
	$configFile = "../config/odyssey.ini.php";
	if(is_file($configFile)){
		include($configFile);
		$dbLink = mysqli_connect($dbHost, $dbUser, $dbPass, $dbName);
		$dbError = mysqli_connect_errno();
    if(empty($dbError)){
		?>
        <script type="text/javascript" language="javascript">
		<?php
		if($installLanguage == 1){
		?>
		alert("Το Odyssey CMS έχει ήδη εγκατασταθεί.\n Αν θέλετε να το εγκαταστήσετε ξανά, θα πρέπει να διαγράψετε το αρχείο\n[config/odyssey.ini.php]\nΣτην περίπτωση αυτή, παρακαλούμε αποθηκεύστε τυχόν δεδομένα που έχετε στην υπάρχουσα βάση δεδομένων");
		<?php
		}else{
		?>
		alert("Odyssey CMS is already installed.\n To install it again you need to remove the file\n[config/odyssey.ini.php]\nIn this case, please backup your database data");
		<?php
		}
		?>
		//document.location.href="index.php";
		</script>
        <?php 
}else{
		?>
        <script type="text/javascript" language="javascript">
		<?php
		if($installLanguage == 1){
		?>
		alert("Βρέθηκε το αρχείο [config/odyssey.ini.php]!\nΓια να αρχίσετε μια νέα εγκατάσταση, θα πρέπει να διαγράψετε το συγκεκριμένο αρχείο");
		<?php
		}else{
		?>			
		alert("The [config/odyssey.ini.php] has been found!\nTo begin a new installation, you need to remove this file");
		<?php
		}
		?>			
		</script>
        <?php 
		exit;	
	}
}
?>
        <input type="hidden" name="step" id="step" value="<?php echo $step + 1; ?>">
        <div style="margin: 60px auto; color:#525252; font-weight:bold; width:600px; ">
            <?php
$messages->printSystemMessages();
?>
            <p><?php echo t("Το πρώτο πράγμα που πρέπει να κάνετε πριν προχωρήσετε στην εγκατάσταση, είναι η δημιουργία μιας βάσης δεδομένων mySQL και ενός χρήστη με πρόσβαση σε αυτήν");?>.</p>
            <p><?php echo t("Για παράδειγμα το όνομα της βάσης και του χρήστη θα μπορούσε να είναι «odyssey», με ένα password της επιλογής σας. Τα στοιχεία αυτά θα σας ζητηθούν κατά την εγκατάσταση");?>.</p>
            <p><?php echo t("Για να το επιτύχετε αυτό, μπορείτε να χρησιμοποιήσετε ένα εργαλείο διαχείρισης βάσης δεδομένων όπως το phpMyAdmin το οποίο διαθέτουν οι περισσότεροι διακομιστές");?>. <br>
                <?php echo t("Σχετικά βοηθήματα σε youTube videos μπορείτε να βρείτε");?> <a href="http://www.youtube.com/results?search_query=phpmyadmin+create+database" target="_blank"><?php echo t("εδώ");?></a>.</p>
            <p><?php echo t("Στη συνέχεια η εγκατάσταση θα σας οδηγήσει με τα κατάλληλα βήματα, ώστε να ολοκληρώσετε την διαδικασία. Το περιβάλλον του διακομιστή σας θα πρέπει να πληροί τις κάτωθι απαιτήσεις");?>: </p>
            <ul>
                <li><?php echo t("Έκδοση PHP >= 5.2.9");?></li>
                <li><?php echo t("Δυνατότητα εκτέλεσης κρυπτογραφημένου κώδικα με IonCube");?></li>
                <li><?php echo t("Δυνατότητα διαχείρισης zip αρχείων μέσω της Zlib library");?></li>
                <li><?php echo t("Δυνατότητα διαχείρισης xml αρχείων μέσω της SimpleXML");?></li>
                <li><?php echo t("Δυνατότητα υποστήριξης mysql / mysqli / mySQL PDO");?></li>
                <?php
	if(ini_get ( "allow_url_fopen" ) != "1") {
	?>
                <li style="border-top: 2px solid red; border-bottom: 2px solid red; margin: 5px 0; padding: 5px 0"><span style="color: #c50000; font-weight:bold"><?php echo t("Προσοχή! Η «allow_url_fopen» δεν έχει οριστεί σωστά");?></span><br>
                    <?php echo t("Η ρύθμιση ( «allow_url_fopen» ) στο php.ini πρέπει να έχει τιμή «1» για να έχετε δυνατότητα SEF URLs");?></li>
                <?php
	}
	?>
            </ul>
            <p> <?php echo t("Επίσης θα πρέπει να υποστηρίζεται η CURL και να ορίσετε εγγράψιμα δικαιώματα ώστε το script να έχει πρόσβαση στους ακόλουθους φακέλους");?>: </p>
            <ul>
                <li>admin/uploads/</li>
                <li>admin/uploads/medium/</li>
                <li>admin/uploads/thumbs/</li>
                <li>admin/xml/</li>
                <li>config/</li>
                <li>controller/</li>
                <li>fonts/</li>
                <li>modules/</li>
                <li>templates/</li>
                <li>mediabank/</li>
                <li>mediabank/banners/</li>
                <li>mediabank/flags/</li>
                <li>mediabank/icons/</li>
                <li>mediabank/images/</li>
                <li>mediabank/medium/</li>
                <li>mediabank/thumbs/</li>
                <li>uploads/</li>
            </ul>
            <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα");?> &gt;&gt;" onClick="return check(<?php echo $step;?>)">
        </div>
        <?php 
}

if($step == 1){
	?>
        <table cellspacing="0" cellpadding="4" style="margin: 60px auto">
            <tr>
                <td style="text-align:right">PHP Version: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($phpVersionError) ? "error.png" : "ok.png";?>' title="<?php echo ($phpVersionError) ? t('Το σύστημα απαιτεί έκδοση PHP >= 5.2.9') : t('Έλεγχος επιτυχής').' - PHP Version: '.phpversion();?>"></td>
            </tr>
            <tr>
                <td style="text-align:right">IonCube Support: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($ioncubeError) ? "error.png" : "ok.png";?>' title="<?php echo ($zipError) ? t('Το σύστημα σας δεν υποστηρίζει εκτέλεση κρυπτογραφημένου κώδικα με IonCube') : t('Έλεγχος επιτυχής');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right">Zlib Support: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($zipError) ? "error.png" : "ok.png";?>' title="<?php echo ($zipError) ? t('Το σύστημα σας δεν υποστηρίζει διαχείριση zip αρχείων') : t('Έλεγχος επιτυχής');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right">Simple XML Support: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($xmlError) ? "error.png" : "ok.png";?>' title="<?php echo ($xmlError) ? t('Το σύστημα σας δεν υποστηρίζει διαχείριση xml αρχείων με SimpleXML') : t('Έλεγχος επιτυχής');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right">MySQL (mysql, mysqli, PDO) Support: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($sqlError) ? "error.png" : "ok.png";?>' title="<?php echo ($sqlError) ? t('Το σύστημα σας δεν υποστηρίζει mySQL για την διαχείριση της βάσης δεδομένων') : t('Έλεγχος επιτυχής');?>"></td>
            </tr>
            <?php $iniError = (ini_get ( "allow_url_fopen" ) != "1") ? true : false; ?>
            <tr>
                <td style="text-align:right"><?php echo t("Ενεργοποίηση της «allow_url_fopen» στο php.ini");?>: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($iniError) ? "error.png" : "ok.png";?>' title="<?php echo ($iniError) ? t('Η «allow_url_fopen» δεν έχει οριστεί ως ενεργή στο php.ini') : t('Έλεγχος επιτυχής');?>"></td>
            </tr>
            <tr>
                <td colspan="2" >&nbsp;</td>
            </tr>
            <tr>
                <td colspan="2" style="background-color: #9a2a54; color:#fff; padding: 5px 30px"><?php echo t("Έλεγχος των φακέλων για εγγράψιμα δικαιώματα (permissions)");?></td>
            </tr>
            <tr>
                <td style="text-align:right; padding-top:15px"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;admin/uploads: </td>
                <td style="padding-top:15px">&nbsp;&nbsp;<img src='images/install_<?php echo ($w_admin_uploads) ? "ok.png" : "error.png";?>' title="<?php echo ($w_admin_uploads) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;admin/uploads/medium: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_admin_uploads_medium) ? "ok.png" : "error.png";?>' title="<?php echo ($w_admin_uploads_medium) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;admin/uploads/thumbs: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_admin_uploads_thumbs) ? "ok.png" : "error.png";?>' title="<?php echo ($w_admin_uploads_thumbs) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;admin/xml: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_admin_xml) ? "ok.png" : "error.png";?>' title="<?php echo ($w_admin_xml) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;config: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_config) ? "ok.png" : "error.png";?>' title="<?php echo ($w_config) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;controller: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_controller) ? "ok.png" : "error.png";?>' title="<?php echo ($w_controller) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;fonts: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_fonts) ? "ok.png" : "error.png";?>' title="<?php echo ($w_fonts) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;modules: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_modules) ? "ok.png" : "error.png";?>' title="<?php echo ($w_modules) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;templates: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_templates) ? "ok.png" : "error.png";?>' title="<?php echo ($w_templates) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/banners: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_banner) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_banner) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/flags: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_flags) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_flags) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/icons: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_icons) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_icons) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/images: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_images) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_images) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/medium: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_medium) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_medium) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;mediabank/thumbs: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_mediabank_thumbs) ? "ok.png" : "error.png";?>' title="<?php echo ($w_mediabank_thumbs) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;"><div class="folder_container"><img src="images/install_folder.png" width="26" height="26" alt="folder" class="folder"></div>
                    &nbsp;uploads: </td>
                <td>&nbsp;&nbsp;<img src='images/install_<?php echo ($w_uploads) ? "ok.png" : "error.png";?>' title="<?php echo ($w_uploads) ? t('Έλεγχος επιτυχής') : t('Ο συγκεκριμένος φάκελος δεν είναι εγγράψιμος');?>"></td>
            </tr>
            <tr>
                <td style="text-align:right;padding:20px 0"><input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα");?> &gt;&gt;" onClick="return check(<?php echo $step;?>)"></td>
                <td>&nbsp;</td>
            </tr>
            <tr>
                <td colspan="2" style="text-align:left; font-size:.9em; font-weight:normal; background: #fff url(images/tip.png) 15px center no-repeat; border: 1px solid silver; padding: 15px 50px"><?php echo t("Σας προτείνουμε να δώσετε εγγράψιμα δικαιώματα και στα αρχεία");?>:<br>
                    <b>PDOErrors.txt</b>, <b>admin/PDOErrors.txt</b>, <?php echo t("ώστε να καταγράφονται τυχόν σφάλματα που σχετίζονται με την βάση δεδομένων");?></td>
            </tr>
        </table>
        <input type="hidden" name="step" id="step" value="<?php echo $step + 1; ?>">
        <?php 
}
if($step == 2){
	$messages->printSystemMessages();
	if((!$messages->hasErrors) && ($_REQUEST['checkDB'])) {
		$step++;
		$_SESSION['dbHost'] = $dbHost;
		$_SESSION['dbName'] = $dbName;
		$_SESSION['dbUser'] = $dbUser;
		$_SESSION['dbPass'] = $dbPass;
		?>
        <script>document.location.href="install.php?step=<?php echo $step;?>";</script>
        <?php 
}else{
		$_SESSION['step'] = $step;
		$dbHost = (empty($_POST['dbHost'])) ? "localhost" : $_POST['dbHost'];
		$dbName = (empty($_POST['dbName'])) ? "odyssey" : $_POST['dbName'];
		unset($_SESSION['__remove_demo_content__'] );
?>
        <div style="margin: 60px auto; display:table; margin: 20px auto">
            <div class="admin_form_element">
                <div class="admin_label"> Database Hostname : </div>
                <div class="normal_wrapper">
                    <input name="dbHost" type="text" value="<?php echo $dbHost;?>" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Database Name : </div>
                <div class="normal_wrapper">
                    <input name="dbName" type="text" value="<?php echo $dbName;?>" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Database User : </div>
                <div class="normal_wrapper">
                    <input name="dbUser" type="text" value="<?php echo $_POST['dbUser'];?>" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Database Password : </div>
                <div class="normal_wrapper">
                    <input name="dbPass" id="dbPass" type="password" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Database Password (<?php echo t("επιβεβαίωση");?>) : </div>
                <div class="normal_wrapper">
                    <input name="dbPassConfirm" id="dbPassConfirm" type="password" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα");?> &gt;&gt;">
                <input type="hidden" name="step" id="step" value="<?php echo $step; ?>">
                <input type="hidden" name="checkDB" value="1">
            </div>
        </div>
        <?php 
}
}
if($step == 3){
	$messages->printSystemMessages();
	if((!$messages->hasErrors) && ($_REQUEST['checkParameters'])) {
		$step++;
		?>
        <script>document.location.href="install.php?step=<?php echo $step;?>&keep_demo_content=<?php echo $_SESSION['keep_demo_content']; ?>";</script>
        <?php 
        unset($_SESSION['keep_demo_content']);
}else{
	$_SESSION['step'] = $step;
?>
        <div style="margin: 60px auto; display:table; margin: 20px auto">
            <div class="admin_form_element">
                <div class="admin_label"> Domain Name : </div>
                <div class="normal_wrapper">
                    <input name="domain_name" type="text" value="<?php echo $_POST['domain_name'];?>" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> <?php echo t("E-mail επικοινωνίας");?> : </div>
                <div class="normal_wrapper">
                    <input name="email_address" type="text" value="<?php echo $_POST['email_address'];?>" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Master Admin password (developer) : </div>
                <div class="normal_wrapper">
                    <input name="adminPass" type="password" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Master Admin password (<?php echo t("επιβεβαίωση");?>) : </div>
                <div class="normal_wrapper">
                    <input name="adminPassConfirm" type="password" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Second Admin Password (client) : </div>
                <div class="normal_wrapper">
                    <input name="clientPass" type="password" class="listbox">
                </div>
            </div>
            <div class="admin_form_element">
                <div class="admin_label"> Second Admin Password (<?php echo t("επιβεβαίωση");?>) : </div>
                <div class="normal_wrapper">
                    <input name="clientPassConfirm" type="password" class="listbox">
                </div>
            </div>
			<div class="admin_form_element">
				<div class="admin_checkbox_wrapper">
				<input name="keep_demo_content" id="keep_demo_content" value="1" type="checkbox">
				<p><?php echo t("Διατήρηση demo περιεχομένου");?></p>
				</div>
			</div>				
            <div class="admin_form_element">
                <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα");?> &gt;&gt;">
                <input type="hidden" name="step" id="step" value="<?php echo $step; ?>">
                <input type="hidden" name="dbHost" id="dbHost" value="<?php echo $_SESSION['dbHost']; ?>">
                <input type="hidden" name="dbName" id="dbName" value="<?php echo $_SESSION['dbName']; ?>">
                <input type="hidden" name="dbUser" id="dbUser" value="<?php echo $_SESSION['dbUser']; ?>">
                <input type="hidden" name="dbPass" id="dbPass" value="<?php echo $_SESSION['dbPass']; ?>">
                <input type="hidden" name="checkParameters" value="1">
            </div>
        </div>
        <?php 
}
}
if($step == 4){
	$messages->printSystemMessages();
	if((!$messages->hasErrors) && ($_SESSION['step3'])) {
		unset($_SESSION['__remove_demo_content__']);
		if(empty($_GET['keep_demo_content'])){
        	$_SESSION['__remove_demo_content__'] = "__remove_demo_content__";
		}	
		?>
        <div style="text-align:center; margin:50px 0 200px 0"> <a href="index.php" class="normal_link"><?php echo t("Μετάβαση στον πίνακα διαχείρισης");?></a> 
            <script>
		setTimeout(function(){
			document.location.href ="index.php";
		}, 10000);
		</script> 
        </div>
        <?php 
}else{
		?>
        <div style="text-align:center; margin:50px 0 200px 0"> <a href="index.php?step=4" class="normal_link"><?php echo t("Δοκιμάστε ξανά");?></a> </div>
        <?php 
}
}
?>
    </form>
    <div style="text-align: center; padding-bottom: 30px">
        <hr>
    </div>
</section>
</body>
</html>
