<?php
/*
Odyssey controller file
$this is a reference to $document
*/

global $library;
global $langID;
include("config/odyssey.ini.php");
foreach ($library as $class) {
    global ${$class};
} // import library classes
$sectionCssFile = $this->getTemplatePath() . $this->cssFilePath . $this->section . ".css";
$sectionJsFile = $this->getTemplatePath() . $this->jsFilePath . $this->section . ".js";
$sectionJsReadyFile = $this->getTemplatePath() . $this->jsFilePath . $this->section . "_ready.js";
// add any other scripts you may need in the following array
$jsFiles = array();

$homePageURL = $parameters->getParameter('homepage');
if ($homePageURL) {
    ?>
    <script>document.location.href="<?php echo $homePageURL;?>";</script>
    <?php
    exit;
}


$table = "odyssey_index";
$content_table = "content_" . $table;
$q = "select 
$content_table.title, 
$content_table.description, 
$table.* 
from 
$table, $content_table 
where 
$table.active=1 
and $table.id=$content_table.mainID 
and $content_table.langID='$langID' 
order by $table.sort limit 1";
$item = $db->getRecord($q);
$id = $item->id;


// seo settings
$thisPage = getBase() . "index.php?section=" . $section . "&view=" . $view . "&id=" . $id . "&r=" . rand();
$seoNotFound = true;
if ($id) {
    $seoQuery = "select * from `seo` where sectionID='$this->sectionID' and itemId='$id' and langID='$langID'";
    $seo = $db->getRecord($seoQuery);
    if (!$seo) {
        $seoNotFound = true;
    } else {
        $seoNotFound = (empty($seo->title) && empty($seo->description) && empty($seo->keywords) && empty($seo->meta));
    }
    if (!$seoNotFound) { // specific seo settings found
        if ($seo->title) $this->setHtmlTitle(strip_tags($seo->title), !$seo->overwrite_title); // in case of true in second argument, the append behavior will be activated
        $meta = array(
            '<meta name="description" content="' . $seo->description . '">',
            '<meta name="keywords" content="' . $seo->keywords . '">',
            '<meta property="og:title" content="' . $seo->title . '">',
            '<meta property="og:type" content="article">',
            '<meta property="og:url" content="' . $sef->url($thisPage, false) . '">',
            '<meta property="og:description" content="' . $seo->description . '">',
            '<meta property="og:image" content="' . getBase() . $this->getTemplatePath() . 'images/fb_default.jpg">'
        );
        $meta_entries = explode(PHP_EOL, $seo->meta);
        $meta = array_merge($meta, $meta_entries);
        $this->setMeta($meta);
    }
}
if ($seoNotFound) { // general settings
// add general meta tags
    $theTitle = NULL;

    $meta = array(
        '<meta name="description" content="' . $parameters->getParameter('description') . '">',
        '<meta name="keywords" content="' . $parameters->getParameter('keywords') . '">',
        '<meta property="og:description" content="' . $parameters->getParameter('description') . '">',
        '<meta property="og:image" content="' . getBase() . $this->getTemplatePath() . 'images/fb_default.jpg">'
    );
    $this->setHtmlTitle(strip_tags($theTitle), true); // true to activate the append behavior
    $this->setMeta($meta);
}

$this->setStyles($sectionCssFile);
$this->setJsFiles($sectionJsFile);
$this->setJsFiles($jsFiles);
$this->setJsReady(is_file($sectionJsReadyFile) ? file_get_contents($sectionJsReadyFile) : null);


// *************************************************************************
// include all controller vars that need to be passed to view in order to encapsulate them

$controllerVars = array('item');
foreach ($controllerVars as $var) {
    $this->$var = ${$var};
    $this->setData($this->$var);
}

// *************************************************************************
?>