<?php
define("CMS", "korCMS");
require_once("functions.php");    // access from root folder
checkInstallation();
require_once("config/odyssey.ini.php");    // access from root folder
filterInvalidRequest();
setErrorReporting();
getHeaders();
importSession();
cleanUpUploads();

$protocol = getProtocol();
$domainPath = $protocol . "://" . $_SERVER['HTTP_HOST'] . "/";
$imports = array();
$library = array();
$phrases = array();
import("library.*", false); // load all Odyssey classes

$messages = new messages();
$auth = new authentication(false);
$categories = new categories();
$content = new content();
$dates = new dates();
$db = new db();
$fileSystem = new fileSystem();
$language = new language();
$menu = new menu();
$parameters = new parameters();
$system = new system();
$variables = new variables();
$timer = new timer();
$banners = new banners();
$sef = new sef();
$force_ssl = $parameters->getParameter("ssl"); // if force SSL URL is enabled or not
if($force_ssl && $protocol != 'https'){ // then force URL to use https
    setSSL();
}
$cache = $parameters->getParameter("cache"); // if DB caching is enabled or not
$is_uc = $parameters->getParameter("uc"); // if this website is under construction
if ($is_uc) $auth = new authentication(true, true); // only admin allowed to view the website in under construction mode
$system->clearLog();

unset($_SESSION['currentLanguage']);
$language->setCurrentLanguage((int)$_REQUEST['langID']);
$langID = $language->getCurrentLanguage();
$langExtension = $language->getLanguageExtension($langID);
$urlExtension = ($langExtension == "_gr") ? NULL : $langExtension;
$spritePath = "mediabank/icons/";
$spriteExt = "png";
$system_fields = array('id', 'active', 'private', 'sort', 'alias', 'parent', 'target', 'access', 'lat', 'lng', 'zoom', 'mainID', 'catID', 'langID');

manageLogout();
manageMultilingual();
cleanUpConnectedUsers();
$_SESSION['ip'] = $_SERVER["REMOTE_ADDR"];
$db->query("SET NAMES 'utf8mb4'");

?>
