<?php 
if(!is_file("config/odyssey.ini.php")){
  header("location: admin/install.php");
  exit;
}
$allQueries = 0;
$cachedQueries=0;
$start_time = microtime(true);
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array('section', 'view'));
$document = new document($section, $view);
$custom_functions = "templates/".$document->getDefaultTemplate()."/functions.php";
if(is_file($custom_functions)) include_once($custom_functions);
$bodyClass = ($urlExtension) ? 'lang'.$urlExtension : "lang_gr";
$langCodes = getLangCodes();
$langCode = $langCodes[str_replace("_", NULL, $language->getLanguageExtension($langID))];
$bodyClass.= ${$document->getDefaultTemplate()."_bodyClass"};
?>
<!DOCTYPE HTML>
<html lang="<?php echo $langCode;?>">
<head>
<?php 
$document->getMeta();
$document->getStyles();
$document->getJsFiles();
$document->getJsReady();
$document->includeModules("plugins");
// add more classes if needed
$bodyClass = ' class="'.$bodyClass.'"';
?>
</head>
<body <?php echo trim($bodyClass);?>>
<?php
$document->getNoScript();
$document->getContent($custom_script); // $custom_script is a value from request in case we want to load a template's custom php script content
$document->includeModules("odyssey");
$document->getBodyJs();
$login = $auth->getLoginStatus();

if(!empty($login)){
	?>
	<script type="text/javascript">
	<!--
	doUpdate();
	var userUpdateStatus = setInterval(doUpdate, 30000);
	function doUpdate(){
		$.ajax({
		  dataType: "json",
		  url: "updateUserStatus.php",
			success: function(data){
				$.each(data, function(key, val) {
					window.userStatus = val.status;
					console.log(window.userStatus);
				});
				if(window.userStatus == "Access Denied"){
					clearInterval(userUpdateStatus);
					<?php
					if($view != "odyssey_index"){
						// logout and exit from any iframe
					?>
					window.top.location.href="index.php?logout=1";
					<?php
					}
					?>
				}
			}
		});		
	}
	-->
	</script>
	<?php	
}else{
	?>
	<script type="text/javascript">
	<!--
	cleanUpUsers();
	var cleanUp = setInterval(cleanUpUsers, 30000);
	function cleanUpUsers(){
		$.ajax({
		  url: "cleanUpUsers.php",
			success: function(response){
				//console.log(response);
			}
		});		
	}
	-->
	</script>
	<?php	
}
$document->printDebug();
?>
<!-- last for override all -->
<style type="text/css">
.nofloat{
	float:none !important;
}
</style>
</body>
</html>