<?php
defined('CMS') or die("This file cannot run this way!");

class admin_pagination
{

    private $presults = null;
    private $numRows = null;
    private $hasDetails = false;
    private $qstring = null;
    private $page = null;
    private $lastPage = null;
    private $offset = null;
    private $leftOffset = null;
    private $rightOffset = null;
    private $trans = array("πρώτη σελίδα" => "first page",
        "προηγούμενη σελίδα" => "previous page",
        "μετάβαση στη σελίδα" => "goto page",
        "επόμενη σελίδα" => "next page",
        "τελευταία σελίδα" => "last page",
    );

    function __construct($numRows, $hasDetails, $vars, $presults = NULL) { // $vars deprecated bat required for compatibility
        $parameters = new parameters();
        $this->presults = (is_numeric($_GET['presults'])) ? (int)$_GET['presults'] : (int)$parameters->getParameter('presults');
        $this->presults = (!empty($presults)) ? (int)$presults : $this->presults;
        $this->prange = $parameters->getParameter('prange');
        $this->hasDetails = $hasDetails;
        $this->qstring = $this->buildQueryString();
        $this->numRows = $numRows;
        $this->page = ($_GET['page']) ? (int)$_GET['page'] : 1;
        $this->lastPage = ceil($this->numRows / $this->presults);
        $this->page = ($this->page > $this->lastPage) ? $this->lastPage : $this->page;
        $this->offset = $this->prange;
        $this->leftOffset = (($this->page - $this->offset) > 0) ? $this->offset : $this->page - 1;
        $this->rightOffset = (($this->page + $this->offset) < $this->lastPage) ? $this->offset : $this->lastPage - $this->page;
    }

    private function buildQueryString() {
        global $safeRequest;
        $pSafeRequest = (array)$safeRequest;
        $get = array_merge(array_keys($_GET), array_keys($_POST));
        $qs = "&";
        for ($i = 0; $i < sizeof($get); $i++) {
            if ($get[$i]) {
                $get[$i] = trim($get[$i]);
                $value = NULL;
                if (array_key_exists($get[$i], $pSafeRequest) && $get[$i] != "ppage") {
                    $value = $pSafeRequest[$get[$i]];
                }
                if (!$value && $get[$i] != "ppage") {
                    // try if a global var exists
                    global ${$get[$i]};
                    $value = ${$get[$i]};
                }
                if ($value) $qs .= $get[$i] . "=" . $value . "&";
            }
        }
        if (!preg_match('/presults=/', $qs)) $qs .= "presults=" . $this->presults . "&";
        return rtrim($qs, "&");
    }

    function printPages() {
        echo "<div id='pagination_container'>";
        $this->printDetails();
        if ($this->numRows <= $this->presults) {
            $this->presultsSelection();
            echo "</div>";
            return; // no need for pagination
        }
        echo("<div class='pagination clearfix'>
		<ol class='clearfix'>");
        if ($this->page > 1) {
            if ($this->page > 2) {
                echo "<li class='pagination_start'>
				<a href='?page=1$this->qstring' title='" . t('πρώτη σελίδα') . "' class='ir'>" . t('πρώτη σελίδα') . "</a>
				</li>";
            }
            $p = $this->page - 1;
            echo "<li class='pagination_previous' rel='previous'>
			<a href='?page=$p$this->qstring' title='" . t('προηγούμενη σελίδα') . "' class='ir'>" . t('προηγούμενη σελίδα') . "</a>
			</li>";
        }
        for ($n = $this->page - $this->leftOffset; $n < $this->page; $n++) {
            echo "<li><a class='numbers' title='" . t('μετάβαση στη σελίδα') . " " . $n . "' href='?page=$n$this->qstring'>$n</a></li>";
        }
        echo "<li class='current'>$this->page</li>";
        $p = $this->page + 1;
        for ($n = $p; $n <= $this->page + $this->rightOffset; $n++) {
            echo "<li><a class='numbers' title='" . t('μετάβαση στη σελίδα') . " " . $n . "' href='?page=$n$this->qstring'>$n</a></li>";
        }
        if ($this->page < $this->lastPage) {
            echo "<li class='pagination_next' rel='next'>
			<a href='?page=$p$this->qstring' title='" . t('επόμενη σελίδα') . "' class='ir'>" . t('επόμενη σελίδα') . "</a>
			</li>";
            if ($this->page < $this->lastPage - 1) {
                echo "<li class='pagination_end'>
				<a href='?page=$this->lastPage$this->qstring' title='" . t('τελευταία σελίδα') . "' class='ir'>" . t('τελευταία σελίδα') . "</a>
				</li>";
            }
        }
        echo("</ol>
		</div><!-- div.pagination -->");
        $this->presultsSelection();
        echo("</div>");
        return true;
    }

    function printDetails() {
        if (!$this->hasDetails) return false; // print nothing!
        $rWord = ($this->numRows > 1) ? $this->numRows . ' ' . t('καταχωρημένες εγγραφές') : $this->numRows . ' ' . t('καταχωρημένη εγγραφή');
        echo "<div class='pages'><div>" . $rWord . "</div> <div>(" . t('σελίδα') . " " . $this->page . " " . t('από') . " " . $this->lastPage . ")</div></div><!-- div.pages -->";
    }

    private function presultsSelection() {
        if (!$this->hasDetails) return;
        $language = new language();
        global $db;
        global $langID;
        if (empty($langID)) $langID = $language->getDefaultLanguage();
        $bordered = ($this->numRows >= $this->presults) ? "bordered" : "";
        $pr = ($_GET['presults']) ? $_GET['presults'] : $this->presults;
        $qs = str_replace("&amp;presults=" . $pr, NULL, $this->qstring);
        echo('
				<script>
		function updatePaginationPage(elm){
		    document.location.href= "?presults=" + $(elm).val() + "' . html_entity_decode($qs) . '";
		}
		</script>
		<div class="presults_numbers ' . $bordered . '" >
		' . t('εμφάνιση') . ' 
		<select id="presults" name="presults" onchange="updatePaginationPage(this)">');
        $numbers = $db->getRecords("select presults_numbers.id, content_presults_numbers.title 
							from presults_numbers, content_presults_numbers 
							where content_presults_numbers.mainID=presults_numbers.id 
							and content_presults_numbers.langID='$langID'");
        foreach ($numbers as $numbersRow) {
            $n = (int)$numbersRow->title;
            $selected = ($this->presults == $n) ? " selected" : "";
            echo('<option value="' . $n . '" ' . $selected . '>' . $n . '</option>');
        }
        echo('</select> ' . t('εγγραφών ανά σελίδα') . '
		</div>
		');

    }

    /*
    private function buildQueryString($qstring){
        $get= array_keys($_GET);
        $qs="&amp;";
        for($i=0; $i < sizeof($get); $i++){
            if($get[$i]){
                $get[$i] = trim($get[$i]);
                $value = $_REQUEST[$get[$i]];
                if(!$value && $get[$i] != "page"){
                    // try if a global var exists
                    global ${$get[$i]};
                    $value = ${$get[$i]};
                }
                if($value && $get[$i] != "page") $qs.=$get[$i]."=".$value."&amp;";
            }
        }
        if(!preg_match('/presults=/', $qs))	$qs.="presults=".$this->presults."&amp;";
        return rtrim($qs, "&amp;");
    }
    */

}// end class

?>