<?php
defined('CMS') or die("This file cannot run this way!");

class pagination
{

    public $presults;
    public $numRows;
    public $hasDetails;
    public $detailsPrinted;
    public $presultsSelectionDisplayed;
    public $qstring;
    public $page;
    public $lastPage;
    public $offset;
    public $leftOffset;
    public $rightOffset;
    public $custom_script_name;

    function __construct($numRows, $hasDetails, $presults = NULL) {
        $parameters = new parameters();
        global $system;
        global $section;
        $this->custom_script_name = $_SESSION['custom_script_name'];
        $presults = (is_numeric($_GET['presults'])) ? (int)$_GET['presults'] : (int)$presults;
        $presults = (!empty($presults)) ? (int)$presults : $system->getPresults($section);
        $this->presults = (is_numeric($presults)) ? $presults : '';
        $this->prange = $parameters->getParameter('prange');
        $this->hasDetails = $hasDetails;
        $this->qstring = $this->buildQueryString(); // if $vars has no value, entire query string will be used
        $this->numRows = $numRows;
        $this->page = (is_numeric($_GET['ppage'])) ? (int)$_GET['ppage'] : 1;
        $this->lastPage = ceil($this->numRows / $this->presults);
        $this->page = ($this->page > $this->lastPage) ? $this->lastPage : $this->page;
        $this->offset = $this->prange;
        $this->leftOffset = (($this->page - $this->offset) > 0) ? $this->offset : $this->page - 1;
        $this->rightOffset = (($this->page + $this->offset) < $this->lastPage) ? $this->offset : $this->lastPage - $this->page;
        $this->presultsSelectionDisplayed = false;
    }

    private function buildQueryString() {
        global $safeRequest;
        $pSafeRequest = (array)$safeRequest;
        $get = array_merge(array_keys($_GET), array_keys($_POST));
        $qs = "&";
        for ($i = 0; $i < sizeof($get); $i++) {
            if ($get[$i]) {
                $get[$i] = trim($get[$i]);
                $value = NULL;
                if (array_key_exists($get[$i], $pSafeRequest) && $get[$i] != "ppage") {
                    $value = $pSafeRequest[$get[$i]];
                }
                if (!$value && $get[$i] != "ppage") {
                    // try if a global var exists
                    global ${$get[$i]};
                    $value = ${$get[$i]};
                    if ($get[$i] == 'PHPSESSID' && $this->custom_script_name) {
                        $value = $pSafeRequest[$get[$i]];
                    }
                }
                if ($value) $qs .= $get[$i] . "=" . $value . "&";
            }
        }
        if (!preg_match('/presults=/', $qs)) $qs .= "presults=" . $this->presults . "&";
        return rtrim($qs, "&");
    }

    function printPages() {
        if ($this->numRows <= $this->presults) {
            if ($this->hasDetails) {
                $this->printDetails();
                $this->detailsPrinted = true;
                $this->presultsSelection();
            }
            return false; // no need for pagination
        }
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        echo PHP_EOL . "<div class='pagination_wrapper'>";
        if (!$this->detailsPrinted) {
            $this->printDetails();
            $this->detailsPrinted = true;
            if ($this->numRows <= $this->presults) {
                if (!$this->presultsSelectionDisplayed) {
                    $this->presultsSelection();
                    $this->presultsSelectionDisplayed = true;
                }
                echo "</div>";
                return; // no need for pagination
            }
        }

        echo("<div class='pagination clearfix'>
		<ol>");
        global $domain_name;
        global $protocol;
        $base_url = ($this->custom_script_name) ? $protocol . '://' . $domain_name . '/' . $this->custom_script_name : basename($_SERVER['SCRIPT_NAME']);
        if ($this->page > 1) {
            if ($this->page > 2) {
                $url = (!$this->custom_script_name) ? $sef->url($base_url . "?" . $this->qstring, false) : $base_url . "?" . $this->qstring;
                echo "<li class='pagination_start'>
				<a data-params='" . $this->qstring . "' href='" . $url . "' title='" . t('πρώτη σελίδα') . "' class='ir'>" . t('πρώτη σελίδα') . "</a>
				</li>";
            }
            $p = $this->page - 1;
            $url = (!$this->custom_script_name) ? $sef->url($base_url . "?ppage=" . $p . $this->qstring, false) : $base_url . "?ppage=" . $p . $this->qstring;
            echo "<li class='pagination_previous' rel='previous'>
			<a data-params='&ppage=" . $p . $this->qstring . "' href='" . $url . "' title='" . t('προηγούμενη σελίδα') . "' class='ir'>" . t('προηγούμενη σελίδα') . "</a>
			</li>";
        }
        for ($n = $this->page - $this->leftOffset; $n < $this->page; $n++) {
            //$url = basename($_SERVER['SCRIPT_NAME']) . "?ppage=" . $n . $this->qstring;
            $url = (!$this->custom_script_name) ? $sef->url($base_url . "?ppage=" . $n . $this->qstring, false) : $base_url . "?ppage=" . $n . $this->qstring;
            echo "<li><a data-params='&ppage=" . $n . $this->qstring . "' class='numbers' title='" . t("μετάβαση στη σελίδα") . " " . $n . "' href='" . $url . "'>" . $n . "</a></li>";
        }
        echo "<li class='current'>" . $this->page . "</li>";
        $p = $this->page + 1;
        for ($n = $p; $n <= $this->page + $this->rightOffset; $n++) {
            //$url = basename($_SERVER['SCRIPT_NAME']) . "?ppage=" . $n . $this->qstring;
            $url = (!$this->custom_script_name) ? $sef->url($base_url . "?ppage=" . $n . $this->qstring, false) : $base_url . "?ppage=" . $n . $this->qstring;
            echo "<li><a data-params='&ppage=" . $n . $this->qstring . "' class='numbers' title='" . t("μετάβαση στη σελίδα") . " " . $n . "' href='" . $url . "'>" . $n . "</a></li>";
        }
        if ($this->page < $this->lastPage) {
            $url = (!$this->custom_script_name) ? $sef->url($base_url . "?ppage=" . $p . $this->qstring, false) : $base_url . "?ppage=" . $p . $this->qstring;
            //$url = basename($_SERVER['SCRIPT_NAME']) . "?ppage=" . $p . $this->qstring;
            echo "<li class='pagination_next' rel='next'>
			<a data-params='&ppage=" . $p . $this->qstring . "' href='" . $url . "' title='" . t('επόμενη σελίδα') . "' class='ir'>" . t('επόμενη σελίδα') . "</a>
			</li>";
            if ($this->page < $this->lastPage - 1) {
                //$url = basename($_SERVER['SCRIPT_NAME']) . "?ppage=" . $this->lastPage . $this->qstring;
                $url = (!$this->custom_script_name) ? $sef->url($base_url . "?ppage=" . $this->lastPage . $this->qstring, false) : $base_url . "?ppage=" . $this->lastPage . $this->qstring;
                echo "<li class='pagination_end'>
				<a data-params='&ppage=" . $this->lastPage . $this->qstring . "' href='" . $url . "' title='" . t('τελευταία σελίδα') . "' class='ir'>" . t('τελευταία σελίδα') . "</a>
				</li>";
            }
        }
        echo("</ol>
		</div><!-- div.pagination -->");
        if (!$this->presultsSelectionDisplayed) {
            $this->presultsSelection();
            $this->presultsSelectionDisplayed = true;
        }
        echo("</div>");
        return true;
    }

    function printDetails() {
        if (!$this->hasDetails) return false; // print nothing!
        $rWord = ($this->numRows > 1) ? $this->numRows . ' ' . t('καταχωρημένες εγγραφές') : $this->numRows . ' ' . t('καταχωρημένη εγγραφή');
        echo "<div class='pages'><div>" . $rWord . "</div> <div>(" . t('σελίδα') . " " . $this->page . " " . t('από') . " " . $this->lastPage . ")</div></div><!-- div.pages -->";
    }

    private function presultsSelection() {
        if (!$this->hasDetails) return;
        global $section;
        global $view;
        global $language;
        global $db;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        global $id;
        global $parameters;
        global $langID;
        global $protocol;
        global $domain_name;
        if (empty($langID)) $langID = $language->getDefaultLanguage();
        $bordered = ($this->numRows >= $this->presults) ? "bordered" : "";
        $pr = (is_numeric($_GET['presults'])) ? (int)$_GET['presults'] : $this->presults;
        $qs = str_replace("&presults=" . $pr, NULL, $this->qstring);
        $sefEnabled = $parameters->getParameter("sef");
        $params = ($sefEnabled) ? 'section=' . $section . '&view=' . $view . '&id=' . $id . '&langID=' . $langID . '&' : NULL;
        if(!$this->custom_script_name) {
            echo('
		<script>
		function getSEFURL(elm){
			var url = "index.php?' . $params . 'presults=" + $(\'#presults\').val() + "' . $qs . '";
			jQuery.ajax({
				type: "POST",
				url: "getSefURL.php",
				data: "url=" + encodeURIComponent(url),
				async: false,
				success: function(sefURL){
					//console.log(sefURL);
					document.location.href = sefURL;
				}
			});
		}
		</script>
		');
        }else {
            $url = $protocol . '://' . $domain_name . '/' . $this->custom_script_name;
            echo('
		<script>
		function getSEFURL(elm){
			var url = "' . $url . '?presults=" + $(\'#presults\').val() + "' . $qs . '";
			document.location.href = url;
		}
		</script>
		');
        }
        echo ('<div class="presults_numbers ' . $bordered . '" >
		' . t('εμφάνιση') . ' 
		<select id="presults" name="presults" onchange="getSEFURL(this)">');
        $numbers = $db->getRecords("select presults_numbers.id, content_presults_numbers.title 
							from presults_numbers, content_presults_numbers 
							where content_presults_numbers.mainID=presults_numbers.id 
							and content_presults_numbers.langID='1' order by CAST(content_presults_numbers.title AS UNSIGNED)");
        foreach ($numbers as $numbersRow) {
            $n = (int)$numbersRow->title;
            $selected = ($this->presults == $n) ? " selected" : "";
            echo('<option value="' . $n . '" ' . $selected . '>' . $n . '</option>');
        }
        echo('</select> ' . t('εγγραφών ανά σελίδα') . '
		</div>
		');

    }


}// end class

?>